<?php
/*
Ailko:
the name of common.inc is changed in common.inc.php because common.inc could be displayed in full in the browser without interpretation and the password would be visible 
common.inc is rewritten to use the msqli interface instead of msql. The latter will no longer be supported by PHP as of version 7.0.0
mysqli is supported as of PHP 4.1
updateTableOne is now a wrapper for updateTableMore 
lastPeriod and lookUpRnd are now wrappers for lookUp 
calls to sql are now all piped to the new function log_and_execute_query($query) that will execute the query
this function will log the calls to and results from sql in the Apache error.log 
to see that file go to XAMPP control panel <logs> on the Apache row and then click Apache (error.log)
creation of connection to the database is now encapsulated in this log_and_execute_query($query) function and only when necessary a connection will be established
the verbosity of some of the functions is decreased
the misuse of * and the non-use of LIMIT 1 in sql statements is corrected
writecookie didn't work for more than 1 value, is now corrected
a function to insert the data from a hashed tabled into a sql table is added, this function is transaction proof
the menu functions instructionMenu and instructionMenuZonderTabelRandare are rewritten, to get rid of a superfluous parameter, better sql queries and make them more readable. To make them
more maintanable they are now wrappers of instructionMenuMetofZonderTabelRand.
if there is only one screen the menu table is not made, so this function can always be used.
there is now a javascript function runAlways that will be run always after the DOM is loaded, you should let it call javascripts you want to call at the start
The function fisherYatesShuffle reshuffles an array in a random, repeatable, and unbiassed (all possible permutations equally likebable) way
If $sattolo = true, the function reshuffles an array in a random, repeatable, but not unbiassed way, only permutations where none of the elements stays at the same place are allowed and equally likable  
startpage function has now a default for the title parameter this will be the name of the script file
added is a second parameter, if it is true the </head> and <body> tags are added, if it is false they are not added and scripts and style sheets can be added by the including script
Matze's special function is kicked out of the standard startpage
Jona's special functions are out commented

To-do:
avoid the error message in create tables when run for the first time in a project
make startpage such that you can run more tabs of firefox and chrome in the same browser for testing interactions 
*/
//voor de creedexperiment server
define ("HOST","localhost");
define ("DBNAME","creede01_mtask");
define ("ADMIN","creede01_mtask");
define ("WWOORD","psvajaxc08");

//If true mysql errors will be streamed to the browsers too 
define ("DEBUG",TRUE); 

//the default tittle for this page is the filename of the includer
$bt=debug_backtrace();
$title=basename($bt[0]['file']);

/*
 *read all commonparameters into the associative array $commonparameters 
 *and for downward compatibility reasons we also put the commonparamers into seperate variables
 */
$sql="SELECT name, value FROM commonparameters";
$result = log_and_execute_query($sql);
$commonparameters=[];
while ($row=mysqli_fetch_array($result))
{
	$commonparameters[$row['name']]=$row['value'];
}
extract($commonparameters);

//$sql="SELECT * FROM commonparameters";
//$result = log_and_execute_query($sql); 
//while ($row=mysqli_fetch_array($result)) {
//	$value=$row['value'];
//	${$row['name']}=$value;
//}		

/*
 *standard HTML, the unlucky name of this function is for downward compatibility reasons
 *$close=True [False] the HTML will be [NOT] closed with </head> and <body>
 *if it is not closed you can add script, link and style tags to the php script before closing it yourself with </head> and <body> 
 *you can add functions to the runAlways javascript function in the header, eg to block certain keys, that will be run everytime the Dom is loaded
 */
function startpage($htitle="", $close=True) {
	global $title;
	
	if ($htitle==""){
		$htitle=$title;
	}
	
echo <<< EOE
	<html>
	<head>
	<title>$htitle</title>
	<meta charset='utf-8' />
	<meta name='robots' content='noindex,nofollow' />
	
	<meta http-equiv='Cache-Control' content='no-cache, no-store, must-revalidate' />
	<meta http-equiv='Pragma' content='no-cache' />
	<meta http-equiv='Expires' content='0' />
		
	<script language="JavaScript">
	
	//makes it possible to disable a link after one click
	function clickAndDisable(link) 
	{
		link.onclick = function(event) 
		{
			event.preventDefault();
		}
	}

	document.addEventListener("DOMContentLoaded", runAlways); 
	function runAlways () {
		document.addEventListener("keydown", killBackSpaceOutsideTextFields);
		document.addEventListener("keydown", killSomeKeys);
	}	
	function killBackSpaceOutsideTextFields(evt){
		var keycode = evt.keyCode;
		if (keycode  == 8 ) {
			var nodeName = evt.target.nodeName.toLowerCase();
			if ((nodeName === 'input' && evt.target.type === 'text') ||
				nodeName === 'textarea') {
			}	
			else {
				evt.preventDefault();
				return false;
			}
		}	
		return true;
	}    
	
	function killSomeKeys(evt){
		var keycode = evt.keyCode;
		var ctrlDown = evt.ctrlKey;
		if (keycode  == 116 ) { //116=F5
			evt.preventDefault();
			return false;
		}
		return true;
	}    
	
	</script>
	
	<link rel="stylesheet" type="text/css" href="buttons.css" />
	<link rel="stylesheet" type="text/css" href="beleggensns.css" />
	<style type="text/css">
	td.menu, tr.menu, th.menu {border: 0};
	</style>
EOE;
	if ($close){
echo <<< EOE
		</head>
		<body>
EOE;
	}
}

/*
 *This function should be used to execute mysql queries.
 *If anything changes in the PHP API for mysql databases there is only one place that is needed to be changed.
 *It creates a mysqli object if none is created yet by this function.
 *It writes errors and results to the log files.
 *It gives in the error log the query before the execution and the results and errors after the execution.
 *It gives a random number to be able to connect queries and results/errors in the log
 *If DEBUG=True it also writes errors to the screen.
 */
function log_and_execute_query($query) {
	global $mysqli, $title;
	
	if (!isset($mysql))
	{
		$mysqli = new mysqli(HOST,ADMIN,WWOORD,DBNAME);
		if ($mysqli->connect_error)
		{
			$mysqli = new mysqli(HOST,ADMIN,"",DBNAME);
			if ($mysqli->connect_error)
			{
				die('Connect Error (' . $mysqli->connect_errno . ') '. $mysqli->connect_error);
			}
		}
	}	
 
        $random_single_use_query_id = mt_rand(10000, 19999);
        $pc_id=$_SERVER['REMOTE_ADDR'];
	$filename=__FILE__; 
	
	error_log($filename . ': pc_id ' . $pc_id . ': query_id ' . $random_single_use_query_id . ': query = '. $query);
        
        if (!$query_result = $mysqli->query($query)) {
            $mysql_errno = $mysqli->errno;
            $mysql_error = $mysqli->error;
            
            if (DEBUG) { //if DEBUG is true writes also an error to the screen
                echo ($title .  ' <BR>query = '. $query. '<br>: failed with errno (' . $mysql_errno . ') and message ' . $mysql_error.'<br>');
            }
            
            error_log($filename . ': pc_id ' . $pc_id . ': query_id ' . $random_single_use_query_id . ': failed with errno (' . $mysql_errno . ') and message ' . $mysql_error);
        } else {
            error_log($filename . ': pc_id ' . $pc_id . ': query_id ' . $random_single_use_query_id . ': antwoord/result gehad');
        }
        
        error_log($filename . ': pc_id ' . $pc_id . ': query_id ' . $random_single_use_query_id . ': afgerond');
        
        return $query_result;
 }

/*
 * Insert functies
 */

/*
 *inserts new record in table
 *example to insert a new decision record: insertRecord("decisions","ppnummer, period, decision, kans, tijd","$ppnummer, $period, '$keus1', 'kans', '$tijd'");
 */
function insertRecord($table_name,$names,$values){
	$sql="INSERT INTO $table_name (".$names.") VALUES (".$values.")";
	$result = log_and_execute_query($sql);
}
 
 
/*
 *inserts rows from a hashed table into a mysql table
 *it is made transaction safe by default
 *this is slower than not transaction safe, so only use transaction safe when filling a table when you want to be sure that either the whole table is filled or nothing is filled
 *if you don't want to have it transaction safe give False as third parameter
 */
function insert_array_in_mysql_table ($table,$array,$transactionsafe=True){             
	if ($transactionsafe)
	{
		log_and_execute_query("START TRANSACTION");
	}

	$errorflag=FALSE;
	foreach ($array as $row){
		$names=key($row);
		$values="'".array_shift($row)."'";
		foreach ($row as $key=>$value){
			$names.=",".$key;
			$values.=",'".$value."'";
		}
		if (!log_and_execute_query("INSERT INTO $table ($names) VALUES ($values)")){
			$errorflag=TRUE;    
		}
	}

	if ($transactionsafe)
	{
		if ($errorflag==TRUE)
		{
			log_and_execute_query("ROLLBACK");    
		}
		else
		{
			log_and_execute_query("COMMIT");
		}
	} 
} 

/*
 *Look up functions
 */
 
/*
 *Lookups last period a decision was saved in results table
 *example to look up the last period that the 12th subject made a decision in part 1: $lastPeriod=lastPeriod("12","1");
 */
function lastPeriod($ppnr,$part)
{
	return lookUp("results","WHERE ppnr ='$ppnr' AND  part ='$part' ORDER BY period DESC LIMIT 1", "period");
}

/*
 *Lookups one variable in one specific record
 *example to look up the role of the 12th subject: $role=lookUp("ppnummers","ppnr=$ppnr","role");
 *returns '' if no data found
 */
function lookUp($table_name,$condition,$name)
{
	$sql="SELECT $name FROM $table_name WHERE $condition";
	$result = log_and_execute_query($sql);
	if ($row=mysqli_fetch_array($result))
	{
		return $row[$name];
	}
	return "";
}

/*
 *Lookups the next free ppnr and creates a ppnummers record for that number 
 */
function lookUpnextppnr ()
{
	$sql="SELECT ppnr FROM ppnummers ORDER BY ppnr DESC LIMIT 1";
	$result = log_and_execute_query($sql);
	$ppnr=1;
	if ($row=mysqli_fetch_array($result))
	{
		$ppnr=$row['ppnr']+1;
	}
	return $ppnr;
}

/*
 *Update functions
 */

 /*
  *Updates one variable in one record
  *example to overwrite the period with 4 for the 12th subject: updateTableOne("ppnummers","ppnr=$ppnr","period","4");
  *This function is written as a wrapper for updateTableMore as not to break the code when anything has to change
  */
function updateTableOne($table_name,$condition,$name,$value)
{
	updateTableMore($table_name,$condition, "$name=\"$value\"");
}

/*
 *Updates more variables in the same record
 *example to example to overwrite the period with 4 and the earnings with 25 for the 12th subject: updateTableOne("ppnummers","ppnr=$ppnr","period=4,earnings=25");
 */
function updateTableMore($table_name,$condition,$updatestring)
{
	$sql="UPDATE $table_name SET ".$updatestring." WHERE ($condition)";
	log_and_execute_query($sql); 
}

/*
 *Menu functions
 */
function instructionMenu($page, $vrijgemaakt, $deel)
{
	return instructionMenuMetofZonderTabelRand($page, $vrijgemaakt,$deel,True);
}

function instructionMenuZonderTabelRand($page, $vrijgemaakt,$deel)
{
	return instructionMenuMetofZonderTabelRand($page, $vrijgemaakt,$deel,False);
}

function instructionMenuMetofZonderTabelRand($page, $vrijgemaakt,$deel,$border)
{
	//de directory name van de page verwijderen
	$page = substr(strrchr($page, '/'),1);
	
	$sql="SELECT filename, nameinmenu FROM instructions WHERE part=$deel";
	$result = log_and_execute_query($sql);
	
	if (mysqli_num_rows($result)<=1)
	{
		return "";
	}

	$thispagepresent=FALSE;
	if ($border)
	{
		$menutable="<table align=center cellpadding=3 border=1 class=roundedcorner bgcolor=#cee3f6><tr>";
	}
	else
	{
		$menutable="<table align=center cellpadding=3 border=0 class=roundedcorner bgcolor=#cee3f6><tr>";
	}
	$i=($deel-1)*100+1;
	while ($row=mysqli_fetch_array($result))
	{
		$filename=$row['filename'];
		$nameinmenu=$row['nameinmenu'];
		$menuarray[$filename]=$nameinmenu;
		if ($filename==$page){
			$menutable .="<td><font size=3 face=arial color=#000066><b>".$nameinmenu."</b></font></td>";
			$thispagepresent=TRUE;
		}else{
			if ($i<=$vrijgemaakt){
				$menutable .="<td><font size=3 face=arial color=#000066><a Href='".$filename."'>".$nameinmenu."</a></font></td>";
			}
			else {
				$menutable .="<td><font size=3 face=arial color=#000066>".$nameinmenu."</font></td>";
			}
		}
		$i++;
	}	
	if (!$thispagepresent)
	{
		RETURN "ERROR! this file is not in the instructions table.";
	}
	RETURN $menutable."</tr></table>";
}

/*
 *Cookie functions
 */

/*
 *writes a cookie
 *example to write the beheerder cookie with the participant number: writecookie("beheerder",$ppnr);
 *You can write more info in one cookie, by adding more parameters an array. The first parameter will be seen as the name of the cookie, the other parameters
 *will be the content as the cookie seperated by - 
 */
function writecookie()
{
	$arg_list = func_get_args();
	$name=array_shift($arg_list);
	$cookie_val=implode("-",$arg_list);
	setcookie($name, $cookie_val); 
}

/*
 *Alternative for PHP > 5.6
 *function writecookie($name,...$values)
 *{
 *	setcookie($name, implode("-",$values));
 *}
*/
 
/*
 *returns a array of the variables saved in the cookie with writecookie
 *example: $ppnr=$readcookie("beheerder")[0];
 */
function readcookie($name)
{
	return explode("-",$_COOKIE[$name]);
}

/*
 *echo's an array in readable format
 *for debugging purposes
 */
function echoarray($array)
{
	echo '<pre>'; print_r($array); echo '</pre>';
}

/*
 *swaps two elements of an array
 */
function arrayswap(&$array, $index1, $index2)
{
        $tmp = $array[$index1];
        $array[$index1] = $array[$index2];
        $array[$index2] = $tmp;
}

/*
 *shuffles the elements of an array randomly and unbiased for all permutations
 *if $satalo = true, the sattalo shuffle will be executed, the shuffle will be cyclical and therefore no element will stay in the same place
 *shuffle functions can be used to randomly assign roles and groups to particicipants, this is more secure than assigning random numbers to participants and sort the results,
 *as it is not for sure that the sort routine will give consistenly the same results w.r.t. ties.
 *this functions can be seeded, and the same seed will give the same result,
 *although from PhP 5.2.1 on the algoritm changed, so if you need to replicate the same sequences for a r&r you may need to use a different PhP version
 *the standard php shuffle function is automatically seeded and won't give the same result twice
 */
function fisherYatesShuffle($items, $seed, $sattolo=False)
{
    @mt_srand($seed);
    for ($i = count($items) - 1; $i > 0; $i--)
    {
        $j = @mt_rand(0, $i-($sattolo?1:0));
	arrayswap($items,$i,$j);
    }
    return $items;
}

/*
 *Strips accents from accented letters in a string and splits IJ and OE
 *Returns a string without accents and splits IJ and OE
 */
function remove_accents($string)
{
    if ( !preg_match('/[\x80-\xff]/', $string) )
    {
        return $string;
    }

    $chars = array(
    // Decompositions for Latin-1 Supplement
    chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
    chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
    chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
    chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
    chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
    chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
    chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
    chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
    chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
    chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
    chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
    chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
    chr(195).chr(156) => 'U', chr(195).chr(157) => 'Y',
    chr(195).chr(159) => 's', chr(195).chr(160) => 'a',
    chr(195).chr(161) => 'a', chr(195).chr(162) => 'a',
    chr(195).chr(163) => 'a', chr(195).chr(164) => 'a',
    chr(195).chr(165) => 'a', chr(195).chr(167) => 'c',
    chr(195).chr(168) => 'e', chr(195).chr(169) => 'e',
    chr(195).chr(170) => 'e', chr(195).chr(171) => 'e',
    chr(195).chr(172) => 'i', chr(195).chr(173) => 'i',
    chr(195).chr(174) => 'i', chr(195).chr(175) => 'i',
    chr(195).chr(177) => 'n', chr(195).chr(178) => 'o',
    chr(195).chr(179) => 'o', chr(195).chr(180) => 'o',
    chr(195).chr(181) => 'o', chr(195).chr(182) => 'o',
    chr(195).chr(182) => 'o', chr(195).chr(185) => 'u',
    chr(195).chr(186) => 'u', chr(195).chr(187) => 'u',
    chr(195).chr(188) => 'u', chr(195).chr(189) => 'y',
    chr(195).chr(191) => 'y',
    // Decompositions for Latin Extended-A
    chr(196).chr(128) => 'A', chr(196).chr(129) => 'a',
    chr(196).chr(130) => 'A', chr(196).chr(131) => 'a',
    chr(196).chr(132) => 'A', chr(196).chr(133) => 'a',
    chr(196).chr(134) => 'C', chr(196).chr(135) => 'c',
    chr(196).chr(136) => 'C', chr(196).chr(137) => 'c',
    chr(196).chr(138) => 'C', chr(196).chr(139) => 'c',
    chr(196).chr(140) => 'C', chr(196).chr(141) => 'c',
    chr(196).chr(142) => 'D', chr(196).chr(143) => 'd',
    chr(196).chr(144) => 'D', chr(196).chr(145) => 'd',
    chr(196).chr(146) => 'E', chr(196).chr(147) => 'e',
    chr(196).chr(148) => 'E', chr(196).chr(149) => 'e',
    chr(196).chr(150) => 'E', chr(196).chr(151) => 'e',
    chr(196).chr(152) => 'E', chr(196).chr(153) => 'e',
    chr(196).chr(154) => 'E', chr(196).chr(155) => 'e',
    chr(196).chr(156) => 'G', chr(196).chr(157) => 'g',
    chr(196).chr(158) => 'G', chr(196).chr(159) => 'g',
    chr(196).chr(160) => 'G', chr(196).chr(161) => 'g',
    chr(196).chr(162) => 'G', chr(196).chr(163) => 'g',
    chr(196).chr(164) => 'H', chr(196).chr(165) => 'h',
    chr(196).chr(166) => 'H', chr(196).chr(167) => 'h',
    chr(196).chr(168) => 'I', chr(196).chr(169) => 'i',
    chr(196).chr(170) => 'I', chr(196).chr(171) => 'i',
    chr(196).chr(172) => 'I', chr(196).chr(173) => 'i',
    chr(196).chr(174) => 'I', chr(196).chr(175) => 'i',
    chr(196).chr(176) => 'I', chr(196).chr(177) => 'i',
    chr(196).chr(178) => 'IJ',chr(196).chr(179) => 'ij',
    chr(196).chr(180) => 'J', chr(196).chr(181) => 'j',
    chr(196).chr(182) => 'K', chr(196).chr(183) => 'k',
    chr(196).chr(184) => 'k', chr(196).chr(185) => 'L',
    chr(196).chr(186) => 'l', chr(196).chr(187) => 'L',
    chr(196).chr(188) => 'l', chr(196).chr(189) => 'L',
    chr(196).chr(190) => 'l', chr(196).chr(191) => 'L',
    chr(197).chr(128) => 'l', chr(197).chr(129) => 'L',
    chr(197).chr(130) => 'l', chr(197).chr(131) => 'N',
    chr(197).chr(132) => 'n', chr(197).chr(133) => 'N',
    chr(197).chr(134) => 'n', chr(197).chr(135) => 'N',
    chr(197).chr(136) => 'n', chr(197).chr(137) => 'N',
    chr(197).chr(138) => 'n', chr(197).chr(139) => 'N',
    chr(197).chr(140) => 'O', chr(197).chr(141) => 'o',
    chr(197).chr(142) => 'O', chr(197).chr(143) => 'o',
    chr(197).chr(144) => 'O', chr(197).chr(145) => 'o',
    chr(197).chr(146) => 'OE',chr(197).chr(147) => 'oe',
    chr(197).chr(148) => 'R',chr(197).chr(149) => 'r',
    chr(197).chr(150) => 'R',chr(197).chr(151) => 'r',
    chr(197).chr(152) => 'R',chr(197).chr(153) => 'r',
    chr(197).chr(154) => 'S',chr(197).chr(155) => 's',
    chr(197).chr(156) => 'S',chr(197).chr(157) => 's',
    chr(197).chr(158) => 'S',chr(197).chr(159) => 's',
    chr(197).chr(160) => 'S', chr(197).chr(161) => 's',
    chr(197).chr(162) => 'T', chr(197).chr(163) => 't',
    chr(197).chr(164) => 'T', chr(197).chr(165) => 't',
    chr(197).chr(166) => 'T', chr(197).chr(167) => 't',
    chr(197).chr(168) => 'U', chr(197).chr(169) => 'u',
    chr(197).chr(170) => 'U', chr(197).chr(171) => 'u',
    chr(197).chr(172) => 'U', chr(197).chr(173) => 'u',
    chr(197).chr(174) => 'U', chr(197).chr(175) => 'u',
    chr(197).chr(176) => 'U', chr(197).chr(177) => 'u',
    chr(197).chr(178) => 'U', chr(197).chr(179) => 'u',
    chr(197).chr(180) => 'W', chr(197).chr(181) => 'w',
    chr(197).chr(182) => 'Y', chr(197).chr(183) => 'y',
    chr(197).chr(184) => 'Y', chr(197).chr(185) => 'Z',
    chr(197).chr(186) => 'z', chr(197).chr(187) => 'Z',
    chr(197).chr(188) => 'z', chr(197).chr(189) => 'Z',
    chr(197).chr(190) => 'z', chr(197).chr(191) => 's'
    );

    $string = strtr($string, $chars);

    return $string;
}



?>