-- phpMyAdmin SQL Dump
-- version 4.7.6
-- https://www.phpmyadmin.net/
--
-- Host: localhost
-- Generation Time: Aug 06, 2019 at 10:44 AM
-- Server version: 5.6.44-cll-lve
-- PHP Version: 5.6.40

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `creede01_mtask`
--

-- --------------------------------------------------------

--
-- Table structure for table `commonparameters`
--

CREATE TABLE `commonparameters` (
  `index` int(11) NOT NULL,
  `name` varchar(36) NOT NULL,
  `value` varchar(36) NOT NULL,
  `comment` varchar(128) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `commonparameters`
--

INSERT INTO `commonparameters` (`index`, `name`, `value`, `comment`) VALUES
(1, 'numberplayers', '22', 'should be a multiple of X (e.g. 2)'),
(2, 'startearnings', '1', 'should be 0 at the start of the session'),
(3, 'test', '0', 'should be 0 at the real experiment!1 means only one group of three'),
(4, 'expnummer', '1719', 'needed for the receipts'),
(5, 'session', '2', 'needed for the receipts'),
(6, 'expters', 'Sonnemans van veelen', 'needed for the receipts'),
(7, 'showupfee', '0', 'showupfee in euros'),
(8, 'exchangerate', '750', 'amount of points that is one euro'),
(35, 'numberperiodspart1', '20', 'number periods first part'),
(36, 'numberperiodspart2', '20', 'number periods second part'),
(38, 'part', '1', 'should be 1 at the start of the experiment'),
(39, 'numberparts', '4', 'number of blocks in experiment'),
(41, 'startexperiment', '1', 'should be 0 at the start of the experiment'),
(42, 'mtasksec', '300', 'seconds of mtask'),
(43, 'language', 'English', 'the language of experiment translations in mtasktext'),
(44, 'mtasknumbertasks', '40', 'maximum number of tries in a block'),
(45, 'treatment', '2', '1 = time constraint,  2 = control'),
(46, 'mtasksize', '10', 'size of matrix'),
(47, 'mtaskthreshold', '4', 'number of correct matrices for getting bonus'),
(48, 'mtasksizebonus', '10', 'size bonus if threshold is reached'),
(50, 'paymentmtaskpart', '2', 'which mtask part is paid (1-4)');

-- --------------------------------------------------------

--
-- Table structure for table `ppnummers`
--

CREATE TABLE `ppnummers` (
  `session` int(11) NOT NULL,
  `ppnr` int(11) DEFAULT NULL,
  `tafelnummer` varchar(4) DEFAULT NULL,
  `part` int(11) NOT NULL,
  `period` int(11) NOT NULL,
  `vrijgemaakt1` int(11) NOT NULL,
  `currentpage` varchar(160) NOT NULL,
  `pucktreatment` int(11) NOT NULL,
  `earningsMtask` int(11) NOT NULL,
  `totverdeuros` decimal(10,2) DEFAULT NULL,
  `clock` varchar(16) NOT NULL,
  `instructionspage` varchar(128) NOT NULL,
  `matrixnr` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `resultsmtask`
--

CREATE TABLE `resultsmtask` (
  `id$` int(11) NOT NULL,
  `session` int(11) NOT NULL,
  `ppnr` int(11) NOT NULL,
  `part` int(11) DEFAULT NULL,
  `period` int(11) DEFAULT NULL,
  `decision` int(11) DEFAULT NULL,
  `juist` int(11) NOT NULL,
  `antwoordgoed` int(11) DEFAULT NULL,
  `seed_matrices` int(11) DEFAULT NULL,
  `tijd` int(11) DEFAULT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `secondsleft` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `resultsmtaskpp`
--

CREATE TABLE `resultsmtaskpp` (
  `index` int(11) NOT NULL,
  `session` int(11) NOT NULL,
  `ppnr` int(11) NOT NULL,
  `period` int(11) NOT NULL DEFAULT '0',
  `nrcorrect` int(11) NOT NULL DEFAULT '0',
  `nrwrong` int(11) NOT NULL DEFAULT '0',
  `secondsleft` int(11) DEFAULT '0',
  `part` int(11) NOT NULL DEFAULT '0',
  `tasktimestart` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `pointsprevious` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `commonparameters`
--
ALTER TABLE `commonparameters`
  ADD PRIMARY KEY (`index`);

--
-- Indexes for table `resultsmtask`
--
ALTER TABLE `resultsmtask`
  ADD PRIMARY KEY (`id$`);

--
-- Indexes for table `resultsmtaskpp`
--
ALTER TABLE `resultsmtaskpp`
  ADD PRIMARY KEY (`index`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `commonparameters`
--
ALTER TABLE `commonparameters`
  MODIFY `index` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=55;

--
-- AUTO_INCREMENT for table `resultsmtask`
--
ALTER TABLE `resultsmtask`
  MODIFY `id$` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `resultsmtaskpp`
--
ALTER TABLE `resultsmtaskpp`
  MODIFY `index` int(11) NOT NULL AUTO_INCREMENT;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
